#include <string.h>
#include <jni.h>
#include <stdio.h>
#include <android/log.h>

#define LOG_TAG "ADCDriverSysfs"
#define LOGI(...) __android_log_print(ANDROID_LOG_INFO,LOG_TAG,__VA_ARGS__)

int check_node()
{
	FILE *fp = NULL;
	fp = fopen("/sys/devices/platform/ioboard-adc/enable", "r"); 
	if (fp != NULL) {
		fclose(fp);
		LOGI("Open success");
		return 1;
	} else {
		LOGI("Open fail");
		return 0;
	}
}

int get_state()
{
	FILE *fp = NULL;
	char buf = '\0';

	fp = fopen("/sys/devices/platform/ioboard-adc/enable", "r");
	if (fp != NULL) {
		fread(&buf, 1, 1, fp);
		fclose(fp);
		return atoi(&buf);
	} else {
		LOGI("Open fail");
		return -1;
	}
}

void set_state(int enable) 
{
	FILE *fp = NULL;
	fp = fopen("/sys/devices/platform/ioboard-adc/enable", "w");
	if (fp != NULL) {
		if (enable == 0)
			fwrite("0", 1, 1, fp);
		else
			fwrite("1", 1, 1, fp);
		fclose(fp);
	} else {
		LOGI("Open fail");
	}
}

int read_samplingrate()
{
	FILE *fp = NULL;
	char buf[4] = {'\0',};
	
	fp = fopen("/sys/devices/platform/ioboard-adc/interval", "r");
	if (fp != NULL) {
		fread(buf, 1, 4, fp);
		fclose(fp);
		return atoi(buf);
	} else {
		LOGI("Open fail");
		return 0;
	}
}

void set_samplingrate(const char* buf) 
{
	FILE *fp = NULL;
	
	fp = fopen("/sys/devices/platform/ioboard-adc/interval", "w");
	if (fp != NULL ) {
		fwrite(buf, 1, 4, fp);
		fclose(fp);
	} else {
		LOGI("Open fail");
	}
}

int read_voltage() 
{
	FILE *fp = NULL;
	char buf[4] = {'\0',};

	fp = fopen("/sys/devices/platform/ioboard-adc/voltage", "r");
	if (fp != NULL) {
		fread(buf, 1, 4, fp);
		fclose(fp);
		return atoi(buf);
	} else {
		LOGI("Open fail");
		return 0;
	}
}

int Java_com_hardkernel_odroid_ADCActivity_checkNode(JNIEnv* env, jobject obj)
{
	return check_node();
}

int Java_com_hardkernel_odroid_ADCActivity_getState(JNIEnv* env, jobject obj)
{
	return get_state();
}

void Java_com_hardkernel_odroid_ADCActivity_setState(JNIEnv* env, jobject obj, int enable)
{
	set_state(enable);
}

int Java_com_hardkernel_odroid_ADCActivity_readSamplingRate(JNIEnv* env, jobject obj)
{
	return read_samplingrate();
}

void Java_com_hardkernel_odroid_ADCActivity_setSamplingRate(JNIEnv* env, jobject obj,
		jstring value)
{
	const char *str;
	str = (*env)->GetStringUTFChars(env, value, NULL);
	set_samplingrate(str);
}

int Java_com_hardkernel_odroid_ADCActivity_readVoltage(JNIEnv* env, jobject obj)
{
	return read_voltage();
}

